''' <summary>
''' Diese Klasse enthlt Methoden zur
''' Formatierung von Verzeichnisinformationen.
''' </summary>
''' <remarks>Diese Klasse enthlt nur Shared-Member.</remarks>
Public Class Format

    ''' <summary>
    ''' Diese Funktion wandelt eine Byteangabe in eine
    ''' geeignete Einheit um und formatiert sie.
    ''' </summary>
    ''' <param name="Bytes">Die Anzahl der Bytes</param>
    ''' <returns>Ein String der <paramref name="Bytes"/>
    ''' in die passende Einheit umgewandelt hat.</returns>
    ''' <remarks>Die Angabe erfolgt auf 2 Dezimalstellen
    ''' genau. Die ursprngliche Anzahl an Bytes wird
    ''' zustzlich in Klammern zurckgegeben.</remarks>
    Shared Function FormatSize(ByVal Bytes As Long) As String
        Dim tmp As Double = Bytes
        If tmp >= 1000 Then
            tmp = tmp / 1024
            If tmp >= 1000 Then
                tmp = tmp / 1024
                If tmp >= 1000 Then
                    tmp = tmp / 1024
                    If tmp >= 1000 Then
                        tmp = tmp / 1024
                        Return tmp.ToString("#,##0.00") & " TB (" & Bytes.ToString("#,###") & " Bytes)"
                    Else
                        Return tmp.ToString("#,##0.00") & " GB (" & Bytes.ToString("#,###") & " Bytes)"
                    End If
                Else
                    Return tmp.ToString("#,##0.00") & " MB (" & Bytes.ToString("#,###") & " Bytes)"
                End If
            Else
                Return tmp.ToString("#,##0.00") & " KB (" & Bytes.ToString("#,###") & " Bytes)"
            End If
        Else
            Return Bytes.ToString("#,###" & " Bytes")
        End If
    End Function
End Class