Public Class frmDirInfo
    'Damit Informationen zu einem Ordner nicht
    'mehrmals ermittelt werden
    Private DirList As List(Of String)

    Private Sub frmDirInfo_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'Initalisierungsarbeiten
        rtfDirInfo.Clear()
        lbStatus.Items.Clear()
        lbStatus.Items.Add("Bereit")
        DirList = New List(Of String)
    End Sub

    Private Sub lbStatus_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles lbStatus.SelectedIndexChanged
        'Die aktuelle Auswahl abrufen
        Dim Str As String = lbStatus.Items.Item(lbStatus.SelectedIndex)
        'Die Positionen fr den Ordnerpfad abrufen
        'Dieser ist in '"' eingeschlossen
        Dim f As Integer = Str.IndexOf(""""c)
        Dim l As Integer = Str.LastIndexOf(""""c)

        'Wird eine Funktion nicht fndig --> beenden
        If f = -1 Or l = -1 Then Exit Sub
        'Ordnerpfad extrahieren
        Str = Str.Substring(f + 1, l - f - 1)
        With rtfDirInfo
            'Ordnerpfad in der RFF finden
            Dim start As Integer = .Find("Ordner: """ & Str & """")
            'Und Markierung darauf setzten
            .Select(start, Str.Length + 10)
            .ScrollToCaret()
            .Focus()
        End With
    End Sub

    Private Sub cmdClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdClear.Click
        'Alles Zurcksetzen
        'Informationen zu Ordner knnen damit
        'wieder neu ermittelt werden
        rtfDirInfo.Clear()
        lbStatus.Items.Clear()
        lbStatus.Items.Add("Bereit")
        DirList.Clear()
    End Sub

    Private Sub cmdDir_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdDir.Click
        'Ordnerauswahl anzeigen
        Dim folderBrowserDLG As FolderBrowserDialog = Me.FolderBrowserDLG
        'Klickt der Benutzer auf OK
        If (folderBrowserDLG.ShowDialog = DialogResult.OK) Then
            'Auftrag verarbeiten
            NewDir(folderBrowserDLG.SelectedPath)
        End If
    End Sub

    Private Sub cmdEnd_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdEnd.Click
        'Programm beenden
        Me.Close()
    End Sub

    Private Sub NewDir(ByVal str As String)
        'Existiert der Ordner
        If Directory.Exists(str) Then
            'Wurden Informationen zum Ordner schon ermittelt
            If Not Me.DirList.Contains(str) Then
                'Informationssammlung starten (asynchron !)
                Dim newItem As New DirectoryInfoExtended(str, False, False)
                'Einen Ereignishandler fr die Callback-Prozedur hinzufgen
                AddHandler newItem.InitalizingFinished, AddressOf EventFinished
                'Der Hilfsliste hinzufgen
                DirList.Add(str)
                'Den Ordnerpfad und normale Informationen 
                'ermitteln und in RTF eintragen
                Dim info As String
                info = "Attribute: " & newItem.Directory.Attributes.ToString & vbNewLine & _
                    "Erstellt am: " & newItem.Directory.CreationTime & vbNewLine & _
                    "Letzter Zugriff am: " & newItem.Directory.LastAccessTime & vbNewLine & _
                    "Letzte nderug am: " & newItem.Directory.LastWriteTime
                AddText(str, info)
                'Status setzen auf 'laden'
                lbStatus.Items.Add("Lade """ & str & """ ...")
            Else
                'Schon einmal ausgewhlt
                With rtfDirInfo
                    'Ordnerpfad in der RFF finden
                    Dim start As Integer = .Find("Ordner: """ & str & """")
                    'Und Markierung darauf setzten
                    .Select(start, str.Length + 10)
                    .ScrollToCaret()
                    .Focus()
                End With
            End If
        Else
            'Status setzen auf 'nicht vorhanden'
            lbStatus.Items.Add("""" & str & """ ungltig")
        End If
    End Sub


    'Fgt der RTF einen Ordner hinzu
    'dir: der Ordner
    'str: die Informationen
    Private Sub AddText(ByVal dir As String, ByVal str As String)
        'Zur spteren Formatierung muss der Text
        'markiert werden
        'Beginn der Markierung (aktuelles Ende der RTF)
        Dim textLength As Integer = rtfDirInfo.TextLength
        'Lnge der Markierung
        Dim length As Integer = dir.Length + 11
        With rtfDirInfo
            'Ordner einfgen
            .AppendText("Ordner: """ & dir & """" & vbNewLine)
            'Markierung setzen
            .Select(textLength, length)
            'Schriftart und Schriftfarbe setzen
            .SelectionFont = New Font(Me.rtfDirInfo.Font, FontStyle.Bold)
            .SelectionColor = Color.Red
            'keine Aufzhlung
            .SelectionBullet = False
            .SelectionIndent = 0
            'Markierung entfernen
            'Einstellungen gelten sonst fr weiteren Text!
            .Select(0, 0)

            'Markierungsdaten aktualisieren
            textLength = rtfDirInfo.TextLength
            length = str.Length
            'Informationen einfgen
            .AppendText(str & vbNewLine)
            'Markierung setzen
            .Select(textLength, length)
            'Schriftart und Schriftfarbe setzen
            .SelectionFont = New Font(Me.rtfDirInfo.Font, FontStyle.Regular)
            .SelectionColor = Color.Black
            'keine Aufzhlung
            .SelectionBullet = True
            .SelectionIndent = 10
            'Markierung entfernen
            'Einstellungen gelten sonst fr weiteren Text!
            .Select(0, 0)
        End With
    End Sub

    'Fgt der RTF Informationen zu einem Ordner hinzu
    'dir: der Ordner
    'str: die Informationen
    Private Sub InsertText(ByVal dir As String, ByVal str As String)
        With rtfDirInfo
            'Sucht den Ordner
            Dim start As Integer = ((.Find("""" & dir & """") + dir.Length) + 3)
            'Markiert das Zeilenendzeichen
            .Select(start, 0)
            'Ersetzt es durch die zustzlichen Informationen
            .SelectedText = (str & vbNewLine)
            'Schriftart und Schriftfarbe setzen
            .SelectionFont = New Font(Me.rtfDirInfo.Font, FontStyle.Regular)
            .SelectionColor = Color.Black
            'Aufzhlungseigenschaften setzen
            .SelectionBullet = True
            .SelectionIndent = 10
            'Markierung entfernen
            'Einstellungen gelten sonst fr weiteren Text!
            .Select(0, 0)
        End With
    End Sub

    Private Delegate Sub EventDelegate(ByVal ExtDirInfo As DirectoryInfoExtended)

    'Eventhandler fr das Ereignis der Klasse
    'wenn alle Informationen ermittelt wurden
    Private Sub EventFinished(ByVal ExtDirInfo As DirectoryInfoExtended)
        'Kommt aus anderem Thread daher Invoke ntig
        'Prfung
        If rtfDirInfo.InvokeRequired Then
            'Invoke --> Funktion gelangt in anderen Thread
            rtfDirInfo.Invoke(New EventDelegate(AddressOf Me.EventFinished), ExtDirInfo)
        Else
            'Eigentlicher Code
            'Erweiterte Informationen ermitteln und in RTF eintragen
            Dim str As String = "Enthaltene Ordner: " & ExtDirInfo.DirCount & vbNewLine & _
                                "Enthaltene Dateien: " & ExtDirInfo.FileCount & vbNewLine & _
                                "Gre: " & Format.FormatSize(ExtDirInfo.FullSize)
            InsertText(ExtDirInfo.Directory.FullName, str)
            'Status setzen auf 'geladen'
            lbStatus.Items.Add("Fertig """ & ExtDirInfo.Directory.FullName & """")
        End If
    End Sub
End Class